// NetoDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetoDemo.h"
#include "NetoDemoDlg.h"
#include "MyDirPickDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

COLORREF const Orange	= RGB(0xFF,0x99,0);
COLORREF const Green	= RGB(0x00,0xFF,0x00);

/////////////////////////////////////////////////////////////////////////////
// CNetoDemoDlg dialog

CNetoDemoDlg::CNetoDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNetoDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNetoDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNetoDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNetoDemoDlg)
	DDX_Control(pDX, IDC_STATIC_MESSAGE, m_Message);
	DDX_Control(pDX, IDC_PROGRESS_TOTAL, m_Total);
	DDX_Control(pDX, IDC_PROGRESS_CURRENT, m_Current);
	DDX_Control(pDX, IDC_BUTTON_STARTSTOP, m_StartStop);
	DDX_Control(pDX, IDC_NETOCTL1, m_Neto);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNetoDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CNetoDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_PATH, OnButtonPath)
	ON_BN_CLICKED(IDC_BUTTON_STARTSTOP, OnButtonStartstop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetoDemoDlg message handlers

BOOL CNetoDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CButton* pRadio = (CButton*)GetDlgItem(IDC_RADIO_UPL);
	pRadio->SetCheck(1);
	
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_COM1);
	pRadio->SetCheck(1);

	pRadio = (CButton*)GetDlgItem(IDC_RADIO_19200);
	pRadio->SetCheck(1);

	char buffer[ 1001 ];
	GetCurrentDirectory( 1000, buffer );
	SetDlgItemText(IDC_EDIT_PATH, buffer );

	m_Current.SetRange( 0, 100 );
	m_Total.SetRange( 0, 100 );

	m_ledRect.top = 290;
	m_ledRect.left = 370;
	m_ledRect.bottom = 310;
	m_ledRect.right = 390;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNetoDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if( m_Neto.IsProtocolRunning())
			SetLed(); /* redraw the led if the protocol is still running */

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNetoDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNetoDemoDlg::OnButtonAdd() 
{
	CFileDialog dlg( TRUE );
	dlg.m_ofn.Flags |= OFN_ALLOWMULTISELECT; /* select more than 1 file possible */
	if( dlg.DoModal() == IDOK )
	{

		CListBox *pBox = (CListBox*) GetDlgItem( IDC_LIST_FILES );

		POSITION pst;
		pst = dlg.GetStartPosition();
		if( pst != NULL )
		{
			while( pst != NULL )
				pBox->AddString( (LPCTSTR) dlg.GetNextPathName( pst ));
		}
		
	}
}

void CNetoDemoDlg::OnButtonRemove() 
{
	CListBox* pBox = (CListBox*)GetDlgItem(IDC_LIST_FILES);
	
	int selected = pBox->GetSelCount();
	if( selected == 0 )
	{
		MessageBox("No files selected", "ERROR INFO", MB_OK | MB_ICONERROR );
		return;
	}

	int *selection;
	selection = new int[ selected + 1 ];
	pBox->GetSelItems( selected+1, selection );

	for( int i = (selected-1); i >= 0 ; i-- )
	{
		pBox->DeleteString(selection[ i ]);
	}
	delete selection;
}

void CNetoDemoDlg::OnButtonPath() 
{
	CMyDirPickDlg  cfdlg(FALSE, NULL, NULL,
						 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ENABLETEMPLATE,
						 NULL, AfxGetApp()->m_pMainWnd);
	cfdlg.m_ofn.hInstance = AfxGetInstanceHandle();
	cfdlg.m_ofn.lpTemplateName = MAKEINTRESOURCE(FILEOPENORD);
	cfdlg.m_ofn.Flags &= ~OFN_EXPLORER;
	CString cstrPath;
	GetDlgItemText( IDC_EDIT_PATH, cstrPath );
	cfdlg.m_ofn.lpstrInitialDir  = (LPSTR)(LPCTSTR)cstrPath;

	if (cfdlg.DoModal() == IDOK)
	{
		cfdlg.m_ofn.lpstrFile[cfdlg.m_ofn.nFileOffset - 1] = 0;		//Nuke the "Junk"
		SetDlgItemText(IDC_EDIT_PATH, cfdlg.m_ofn.lpstrFile );
    }
}

void CNetoDemoDlg::OnButtonStartstop() 
{
	CString btnText;
	
	m_StartStop.GetWindowText( btnText );
	if( btnText.Compare("&Stop") == 0 )
	{
		m_Neto.StopRunning();
		return;
	}
	
	m_Message.SetWindowText("");

	m_Neto.SetComport( GetCom() );
	m_Neto.SetBaudrate( GetBaudrate());
	m_Neto.SetParity( 0 );		/* No Parity */
	m_Neto.SetByteSize( 8 );	/* 8 databits per byte */
	m_Neto.SetStopBits( 0 );	/* 1 StopBit */
	m_Neto.SetPollSpeed( 250 ); /* 250 ms per poll is 4 polls per second */
	m_Neto.SetPollTimeout( -1L ); /* no timeout */
	m_Neto.SetIrDADevice( 0 );	/* No irda device connected to the COM port */
	m_Neto.SetRxTxDelay( 1 );	/* 1 ms delay between sending receiving */

	VARIANT     varFiles;
	BSTR*       bstrArray;
	CListBox* pBox = (CListBox*)GetDlgItem(IDC_LIST_FILES);
	CString  file_from_list;
	
	VariantInit(&varFiles);
	varFiles.vt = VT_ARRAY | VT_BSTR;
	if( pBox->GetCount() != LB_ERR )
	{
		SAFEARRAYBOUND bounds[] = {pBox->GetCount(), 0 };
		SAFEARRAY* pArray = SafeArrayCreate(VT_BSTR, 1, bounds);

		SafeArrayAccessData(pArray, (void**)&bstrArray);

		for( int i = 0; i < pBox->GetCount(); i++ )
		{
			pBox->GetText( i, file_from_list );
			bstrArray[i] = file_from_list.AllocSysString();
		}

		SafeArrayUnaccessData(pArray);
		varFiles.parray = pArray;
	}

	short ret;
	CString strRcvDir;
	CEdit* edit = (CEdit*) GetDlgItem( IDC_EDIT_PATH );
	edit->GetWindowText( strRcvDir );
	if( (ret = m_Neto.UpDownload("&&&&&&", varFiles, (LPCTSTR)strRcvDir, 1, GetComType() )) < 0 )
	{
		CString strMsg;
        if( ret == -6 || ret == -7 )
            strMsg = "Files not set";
        else if( ret == -3 )
            strMsg = "Pathname is not set";
        else
            strMsg = "undefined error";

        MessageBox( (LPCTSTR)strMsg, "Error", MB_OK | MB_ICONERROR );
		return;
	}
	m_StartStop.SetWindowText("&Stop");

	m_ledColor = Orange;
	SetLed();
}



short CNetoDemoDlg::GetCom()
{
	CButton* pRadio = (CButton*)GetDlgItem(IDC_RADIO_COM1);
	if( pRadio->GetCheck())
		return 1;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_COM2);
	if( pRadio->GetCheck())
		return 2;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_COM3);
	if( pRadio->GetCheck())
		return 3;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_COM4);
	if( pRadio->GetCheck())
		return 4;
	return -1L;
}

long CNetoDemoDlg::GetBaudrate()
{
	CButton* pRadio = (CButton*)GetDlgItem(IDC_RADIO_4800);
	if( pRadio->GetCheck())
		return 4800L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_9600);
	if( pRadio->GetCheck())
		return 9600L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_19200);
	if( pRadio->GetCheck())
		return 19200L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_38400);
	if( pRadio->GetCheck())
		return 38400L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_57600);
	if( pRadio->GetCheck())
		return 57600L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_115200);
	if( pRadio->GetCheck())
		return 115200L;
	return -1L;
}

long CNetoDemoDlg::GetComType()
{
	CButton* pRadio = (CButton*)GetDlgItem(IDC_RADIO_UPL);
	if( pRadio->GetCheck())
		return 0L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_DWN);
	if( pRadio->GetCheck())
		return 1L;
	pRadio = (CButton*)GetDlgItem(IDC_RADIO_UPLDWN);
	if( pRadio->GetCheck())
		return 2L;
	return -1L;
}

BEGIN_EVENTSINK_MAP(CNetoDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CNetoDemoDlg)
	ON_EVENT(CNetoDemoDlg, IDC_NETOCTL1, 2 /* Progress */, OnProgressNetoctl1, VTS_I2 VTS_I2 VTS_I2)
	ON_EVENT(CNetoDemoDlg, IDC_NETOCTL1, 3 /* ProtocolMessage */, OnProtocolMessageNetoctl1, VTS_I2 VTS_BSTR VTS_I2 VTS_I2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CNetoDemoDlg::OnProgressNetoctl1(short Current, short Total, short Comport) 
{
    if( Total != 0 && Current != 0 )
		m_ledColor = Green;
	SetLed();

	m_Current.SetPos( Current );
	m_Total.SetPos( Total );
}

void CNetoDemoDlg::OnProtocolMessageNetoctl1(short msgCode, LPCTSTR strMessage, short final, short Comport) 
{
	m_Message.SetWindowText( strMessage );
    if( final == 1 )
    {
		m_StartStop.SetWindowText("&Start");
		RedrawWindow();        
    }
}

void CNetoDemoDlg::SetLed( void )
{
	CDC *pDC;
	CPen   BlackPen1(PS_SOLID, 1, RGB(0,0,0));
	CBrush Brush( m_ledColor);

	pDC = GetDC();

	CPen*   pOldPen   = pDC->SelectObject( &BlackPen1 );
	CBrush* pOldBrush = pDC->SelectObject( &Brush );

	pDC->Ellipse( &m_ledRect );

	pDC->SelectObject( pOldPen );
	pDC->SelectObject( pOldBrush );
	ReleaseDC( pDC );
	InvalidateRect( &m_ledRect, FALSE );
}


